include_guard(GLOBAL)

@PACKAGE_INIT@

include(CMakeFindDependencyMacro)
find_dependency(Python COMPONENTS Interpreter Development)
find_dependency(nanobind)

# TODO: use automatic check from generated target file
# include(${CMAKE_CURRENT_LIST_DIR}/@PROJECT_NAME@-targets.cmake)

set(_IMPORT_PREFIX "@CMAKE_INSTALL_PREFIX@")

# Create imported target nanobind
add_library(nanobind SHARED IMPORTED)

set_target_properties(nanobind PROPERTIES
  INTERFACE_COMPILE_DEFINITIONS "NB_SHARED"
  INTERFACE_COMPILE_FEATURES "cxx_std_17"
  INTERFACE_INCLUDE_DIRECTORIES "${Python_INCLUDE_DIRS};${NB_DIR}/include"
  INTERFACE_LINK_LIBRARIES "Python::Module"
)

if(UNIX)
set_target_properties(nanobind PROPERTIES
  IMPORTED_LOCATION "${_IMPORT_PREFIX}/compass/libnanobind.so"
  IMPORTED_SONAME "libnanobind.so"
)
endif()

if(WIN32)
set_target_properties(nanobind PROPERTIES
  IMPORTED_LOCATION "${_IMPORT_PREFIX}/compass/nanobind.dll"
  IMPORTED_IMPLIB "${_IMPORT_PREFIX}/compass/nanobind.lib"
)
endif()

# Cleanup temporary variables.
set(_IMPORT_PREFIX)

# TODO: manage different configurations

# TODO: reactivate this
#check_required_components(@PROJECT_NAME@)

execute_process(
  COMMAND compass cmake-dir --as-posix
  OUTPUT_VARIABLE COMPASS_CMAKE_DIR
  OUTPUT_STRIP_TRAILING_WHITESPACE)

list(PREPEND CMAKE_MODULE_PATH ${COMPASS_CMAKE_DIR})

include(compass)
